using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Utilities.BookingGroup.Cqrs;

public class DeleteBookingGroupByIdRequest
{
    public DeleteBookingGroupByIdRequest(string id) => Id = id;
    public string Id { get; set; }
}

public record DeleteBookingGroupByIdCommand(DeleteBookingGroupByIdRequest Data) : IRequest<bool>;

public class DeleteBookingGroupByIdHandler : IRequestHandler<DeleteBookingGroupByIdCommand, bool>
{
    private readonly AppDbContext _context;

    public DeleteBookingGroupByIdHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteBookingGroupByIdCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.BookingGroup
            .FirstOrDefaultAsync(x => x.Id == request.Data.Id, cancellationToken);

        if (entity == null)
        {
            return false;
        }

        _context.BookingGroup.Remove(entity);
        return await _context.SaveChangesAsync(cancellationToken) > 0;
    }
}